#ifndef UUCodeHPP
#define UUCodeHPP
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <System.hpp>

namespace Uucode
{
//-- type declarations -------------------------------------------------------
class __declspec(delphiclass) EUUCode;
class __declspec(pascalimplementation) EUUCode : public Sysutils::Exception
{
  typedef Sysutils::Exception inherited;
public:
  /* Exception.Create */
  __fastcall EUUCode(const System::AnsiString Msg) :
             Sysutils::Exception(Msg) {}
  /* Exception.CreateFmt */
  __fastcall EUUCode(const System::AnsiString Msg, const System::TVarRec* Args, const int Args_Size) :
             Sysutils::Exception(Msg, Args, Args_Size) {}
  /* Exception.CreateRes */
  __fastcall EUUCode(int Ident) :
             Sysutils::Exception(Ident) {}
  /* Exception.CreateResFmt */
  __fastcall EUUCode(int Ident, const System::TVarRec* Args, const int Args_Size) :
             Sysutils::Exception(Ident, Args, Args_Size) {}
  /* Exception.CreateHelp */
  __fastcall EUUCode(const System::AnsiString Msg, int AHelpContext) :
             Sysutils::Exception(Msg, AHelpContext) {}
  /* Exception.CreateFmtHelp */
  __fastcall EUUCode(const System::AnsiString Msg, const System::TVarRec* Args, const int Args_Size, int AHelpContext) :
             Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) {}
  /* Exception.CreateResHelp */
  __fastcall EUUCode(int Ident, int AHelpContext) :
             Sysutils::Exception(Ident, AHelpContext) {}
  /* Exception.CreateResFmtHelp */
  __fastcall EUUCode(int Ident, const System::TVarRec* Args, const int Args_Size, int AHelpContext) :
             Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) {}
public:
  /* TObject.Destroy */
  __fastcall virtual ~EUUCode(void) {}
};

enum TAlgorithm {filecopy, uuencode, uudecode, xxencode, xxdecode, base64encode, base64decode};

enum TUnixCRLF {CRLF, LF};

typedef void __fastcall (__closure *TProgressEvent)(Word Percent);

class __declspec(delphiclass) TUUCode;
class __declspec(pascalimplementation) TUUCode : public Classes::TComponent
{
  typedef Classes::TComponent inherited;

public:
  __fastcall virtual TUUCode(Classes::TComponent* AOwner);

private:
  System::ShortString FAbout;
  bool FActive;
  TAlgorithm FAlgorithm;
  Word FFileMode;
  bool FHeaders;
  System::AnsiString FInputFileName;
  System::AnsiString FOutputFileName;
  TProgressEvent FOnProgress;
  TUnixCRLF FUnixCRLF;
  void __fastcall Dummy( System::ShortString &Ignore);

protected:
  void __fastcall Activate(bool GoActive);

public:
  void __fastcall UUCode(void);

__published:
  __property System::ShortString About = {read=FAbout, write=Dummy};
  __property bool Active = {read=FActive, write=Activate, nodefault};
  __property TAlgorithm Algorithm = {read=FAlgorithm, write=FAlgorithm, nodefault};
  __property Word FileMode = {read=FFileMode, write=FFileMode, nodefault};
  __property bool Headers = {read=FHeaders, write=FHeaders, nodefault};
  __property System::AnsiString InputFile = {read=FInputFileName, write=FInputFileName, nodefault};
  __property System::AnsiString OutputFile = {read=FOutputFileName, write=FOutputFileName, nodefault};
  __property TUnixCRLF UnixCRLF = {read=FUnixCRLF, write=FUnixCRLF, nodefault};
  __property TProgressEvent OnProgress = {read=FOnProgress, write=FOnProgress};

public:
  /* TComponent.Destroy */ __fastcall virtual ~TUUCode(void) {}
}; // TUUCode

}  /* namespace Uucode */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Uucode;
#endif
//-- end unit ----------------------------------------------------------------
#endif  // UUCode
